function [fim, timem] = fairness_index()
% FAIRNESS_INDEX 
%  Calculate fairness index of streams

% $Id: fairness_index.m,v 1.2 1997/04/24 15:14:51 puhuri Exp $
% $Log: fairness_index.m,v $
% Revision 1.2  1997/04/24 15:14:51  puhuri
% Palauttaa kaksi vektoria kaksisarakkeisen matriisin asemasta.
%
% Revision 1.1  1997/04/17 13:45:59  puhuri
% Initial revision
%

% Basic variables
colors = [ 'y', 'm', 'c', 'r', 'g', 'b'];
lshape = [ ' - : -. -- '];
sdel = findstr(lshape, ' ');
pshape = [ '.', 'o', 'x', '+', '*'];

% Find out how much we have...
% (which measurement is underway..)
cwd=pwd;
diridx=findstr(cwd,'/');
mitta=cwd(diridx(length(diridx))+1:length(cwd));
[nowork, rest] = strtok(mitta, 'tw');
work=strtok(rest,'tw') ;             
nowork=str2num(nowork);
work=str2num(work);

tn=(25:5:45) * 1e6;		% 5 secons spacing
seqs = zeros(work, length(tn));

for i = 0:work-1,
  fname = sprintf('sending.%d.ft',i);
  ft=readmtrx(fname);
  for j=1:length(tn),
    st = length(ft) / 2;
    in = st;
    while st > 10,
      st = st / 2;
      if tn(j) <= ft(in),
	in = in - st;
      else
	in = in + st;
      end
    end
    if tn(j) <= ft(in), in = in - st; end
    for in=in:length(ft),
      if tn(j) <= ft(in), break, end
    end
    seqs(i+1,j) = in;
  end
end

seqs = seqs * 1460;
fim = zeros(length(tn),2);
% overall
sum = 0;
qsum = 0;
for i = 1:work,
  sum = sum + (seqs(i,length(tn)) - seqs(i,1));
  qsum = qsum + (seqs(i,length(tn)) - seqs(i,1))^2;
end
fim(1) = sum^2 / (work*qsum);

for j=2:length(tn)
  sum = 0;
  qsum = 0;
  for i = 1:work,
    sum = sum + (seqs(i,j) - seqs(i,j-1));
    qsum = qsum + (seqs(i,j) - seqs(i,j-1))^2;
  end
  fim(j) = sum^2 / (work*qsum);
end
timem=tn/1e6;
